<?php
/*
 * This file contains all common functions, used by the graphical user interface (gui) of the jupload.php script.
 * 
 * It could be reused by other scripts: these fuctions are copy/paste from the main scripts (like upload.php)
 * 
 */

if (!defined('IN_COPPERMINE')) { die('Not in Coppermine...');}
if (!defined('JUPLOAD_PHP')) { die('Not in Jupload...');}



//This function displays the success message resulting of an action (creation or modification of album for instance)
function message_success ($action, $album = 0) {
	global $lang_jupload_php, $lang_login_php, $lang_continue;
	$url = "jupload.php" . ( ($album>0) ? "?album=$album" : '');
    pageheader($lang_login_php['success'], '<META http-equiv="refresh" content="3;url=' . $url . '">');
    msg_box($lang_jupload_php['success'], $lang_jupload_php['success'], $lang_continue, $url);
    pagefooter();
    exit;
}

function create_form(&$data)
{
        foreach($data as $element){
                if ((is_array($element))) {
                    switch($element[2]){
                            case 0 :
                                    form_input($element[0], $element[1], $element[3]);
                                    break;
                            case 1 :
                                    form_alb_list_box($element[0], $element[1]);
                                    break;
                            case 1.1 : //Specific form_alb_list_box_pic function, from the editpics.php script
                                    form_alb_list_box_pic($element[0], $element[1]);
                                    break;
                            case 2 :
                                    form_textarea($element[0], $element[1], $element[3]);
                                    break;
                            case 3 :
                                    form_pic_info($element[0]);
                                    break;
                            case 4 :
                                    form_options();
                                    break;
                            case 5 :
                                    form_hidden($element[0], $element[1]);
                                    break;
                                  
                            default:
                                        cpg_die(CRITICAL_ERROR, 'Invalid action for form creation', __FILE__, __LINE__);
                    } // switch
                } else {
                        form_label($element);
                }
        }
}


// The function to create the album list drop down.
//Etienne Gauthier : add of the $jsEvent parameter : it allows the caller to precise a javascript event, 
 //like onChange. 
function form_alb_list_box($text, $name, $jsEvent='') {
// frogfoot re-wrote this function to present the list in categorized, sorted and nicely formatted order

    // Pull the $CONFIG array and the GET array into the function
    global $CONFIG, $lang_upload_php, $lang_jupload_php, $album;

    // Also pull the album lists into the function
    global $user_albums_list, $public_albums_list;

    // Create the opening of the drop down box
    echo <<<EOT
    <tr>
        <td class="tableb">
            $text
        </td>
        <td class="tableb" valign="top">
            <select name="$name" class="listbox" $jsEvent>

EOT;

    // Reset counter
    $list_count = 0;

    // Cycle through the User albums
    foreach($user_albums_list as $a) {

        // Add to multi-dim array for later sorting
        $listArray[$list_count]['cat'] = $lang_upload_php['personal_albums'];
        $listArray[$list_count]['aid'] = $a['aid'];
        $listArray[$list_count]['title'] = $a['title'];
        //EGR : add of the description to this interesting array.
        $listArray[$list_count]['description'] = $a['description'];
        $list_count++;
    }

    // Cycle through the public albums
    foreach($public_albums_list as $a) {

        // Set $a to the real album ID
        $aid = $a['aid'];

        // Get the category name
        $vQuery = "SELECT cat.name "
        		. " FROM " . $CONFIG['TABLE_CATEGORIES'] . " cat, " . $CONFIG['TABLE_ALBUMS'] . " alb " 
        		. " WHERE alb.aid='" . $aid . "' AND cat.cid=alb.category";
        $vRes = cpg_db_query($vQuery);
        $vRes = mysql_fetch_array($vRes);

        // Add to multi-dim array for sorting later
        if ($vRes['name']) {
            $listArray[$list_count]['cat'] = $vRes['name'];
        } else {
            $listArray[$list_count]['cat'] = $lang_upload_php['albums_no_category'];
        }
        $listArray[$list_count]['aid'] = $a['aid'];
        $listArray[$list_count]['title'] = $a['title'];
        $listArray[$list_count]['description'] = $a['description'];
        $list_count++;
    }

    // Sort the pulldown options by category and album name
    $listArray = array_csort($listArray,'cat','title');

    // Finally, print out the nicely sorted and formatted drop down list
    $alb_cat = '';
	echo '                <option value="">' . $lang_upload_php['select_album'] . "</option>\n";
    foreach ($listArray as $val) {
        if ($val['cat'] != $alb_cat) {
			if ($alb_cat) echo "                </optgroup>\n";
            echo '                <optgroup label="' . $val['cat'] . '">' . "\n";
            $alb_cat = $val['cat'];
        }
        echo '                <option value="' . $val['aid'] . '"' . ( ($val['aid'] == $album) ? ' SELECTED' : '') . '>   ' . $val['title'] . "</option>\n";
    }
    if ($alb_cat) echo "                </optgroup>\n";

    // Close the drop down
    echo <<<EOT
            </select>
        </td>
    </tr>

EOT;
}


//An evolution of the form_alb_list_box function, adapated for the jupload/edit_uploaded_pic.php script
//It is taken from the editpics.php, and renamed. 
//See the form_alb_list_box function, to know how to call it.  
function form_alb_list_box_pic($text, $name)
{
	global $CURRENT_PIC;
	return form_alb_list_box($text, $name . $CURRENT_PIC['pid']);
/*
        global $CONFIG, $CURRENT_PIC;
        global $user_albums_list, $public_albums_list;

        $sel_album = $CURRENT_PIC['aid'];

        $name .= $CURRENT_PIC['pid'];
        echo <<<EOT
        <tr>
            <td class="tableb" style="white-space: nowrap;">
                        $text
        </td>
        <td class="tableb" valign="top">
                <select name="$name" class="listbox">

EOT;
                foreach($public_albums_list as $album) {
        echo '              <option value="' . $album['aid'] . '"' . ($album['aid'] == $sel_album ? ' selected' : '') . '>' . $album['cat_title'] . "</option>\n";
    }
                foreach($user_albums_list as $album){
                        echo '                        <option value="'.$album['aid'].'"'.($album['aid'] == $sel_album ? ' selected' : '').'>* '.$album['title'] . "</option>\n";
                }
        echo <<<EOT
                        </select>
                </td>
        </tr>

EOT;
*/
}

function form_hidden($name, $value)
{
    global $CURRENT_PIC;

    $value = $CURRENT_PIC[$name];
    $name .= $CURRENT_PIC['pid'];
    
	//echo("<input type='hidden' name='$name' value='$value' />");

    echo <<<EOT
        <tr>
            <td class="tableb" style="white-space: nowrap;">
                        $text
        </td>
        <td width="100%" class="tableb" valign="top">
                <input type='hidden' name='$name' value='$value' />
                </td>
        </tr>

EOT;
}


function form_input($text, $name, $max_length,$field_width=100)
{
    global $CURRENT_PIC;

    $value = $CURRENT_PIC[$name];
    $name .= $CURRENT_PIC['pid'];
    if ($text == '') {
        echo "        <input type=\"hidden\" name=\"$name\" value=\"\" />\n";
        return;
    }

    echo <<<EOT
        <tr>
            <td class="tableb" style="white-space: nowrap;">
                        $text
        </td>
        <td width="100%" class="tableb" valign="top">
                <input type="text" style="width: {$field_width}%" name="$name" maxlength="$max_length" value="$value" class="textinput" />
                </td>
        </tr>

EOT;
}

// The form label creation function. Takes a non-array element form $data as its argument.
//if $replace1 is given, all occurences of $1 is replaced by it (I don't like printf functions) 
function form_label($text, $replace1='') {
	if ($replace1 != '') {
		$t = str_replace('$1', $replace1, $text);
	} else {
		$t = $text;
	}
    echo <<<EOT
        <tr>
                <td class="tableh2" colspan="2">
                        <b>$t</b>
                </td>
        </tr>

EOT;
}

// The form statement creation function. Takes a non-array element form $data as its argument.
function form_statement($text) {
    echo <<<EOT
        <tr>
                <td class="tableb" colspan="2">
                        $text
                </td>
        </tr>

EOT;
}

function form_textarea($text, $name, $max_length)
{
        global $ALBUM_DATA, $CURRENT_PIC;

        $value = $CURRENT_PIC[$name];

        $name .= $CURRENT_PIC['pid'];
        echo <<<EOT
        <tr>
                <td class="tableb" valign="top" style="white-space: nowrap;">
                        $text
                </td>
                <td class="tableb" valign="top">
                        <textarea name="$name" rows="5" cols="40" class="textinput" style="width: 100%;" onkeydown="textCounter(this, $max_length);" onkeyup="textCounter(this, $max_length);">$value</textarea>
                </td>
        </tr>
EOT;
}


// The hidden form input function. Takes the hidden input field name and value.
function hidden_input($name, $value) {
        echo <<<EOT
        <tr>
            <td colspan="2">
                   <input type="hidden" name="$name" value="$value" />
            </td>
        </tr>

EOT;
}

// The text box form input function. Takes the text label for the box, the input name, the maximum length for text boxes,
// and the number of iterations.
function text_box_input($text, $name, $max_length, $iterations, $default='') {

    global $CONFIG;

    $ordinal = '';

    if (($text == '') and ($iterations == '')) {
        echo "        <input type=\"hidden\" name=\"$name\" value=\"$default\" />\n";
        return;
    }

    // Begin loop
    for ($counter=0; $counter<$iterations; $counter++) {

    // Create a numbering system when necessary.
    if ($text == '') {
        $cardinal = $counter + 1;
        $ordinal = "".$cardinal.". ";
    }

    // Create a text box.
    echo <<<EOT
        <tr>
            <td width="40%" class="tableb">
                        $text  $ordinal
        </td>
        <td width="60%" class="tableb" valign="top">
                <input type="text" style="width: 100%" name="$name" maxlength="$max_length" value="$default" class="textinput" />
                </td>
        </tr>

EOT;
    }
}


// The function for text areas on forms. Takes the label, field name, and maximum length as arguments.
function text_area_input($text, $name, $max_length,$default='') {

    // Create the text area.
    echo <<<EOT
        <tr>
                <td class="tableb" valign="top">
                        $text
                </td>
                <td class="tableb" valign="top">
<f></f>                        <textarea name="$name" rows="5" cols="40" class="textinput" style="width: 100%;" onKeyDown="textCounter(this, $max_length);" onKeyUp="textCounter(this, $max_length);">$default</textarea>
                </td>
        </tr>
EOT;
}



// Creation of one or many submit buttons.
//If one : just give its value.
//If many (or one with js events), give an array of array. The second array should have the following keys :
//   - value (mandatory) : the value of the button
//   - js    (optional)  : the js event to handle.
function submit_button($buttons) {
  global $lang_upload_php;  
  $buttonsHtml = '';
  
  if (is_array($buttons)) {
    foreach ($buttons as $button) {
      if ($buttonsHtml != '') {
        $buttonsHtml .= '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
      }
      $buttonsHtml .= '<input type="submit" value="' . $button['value'] . '" class="button" ' 
          . ( (isset($button['js'])) ? $button['js'] : '')
          . ' />';
    }//foreach
  } else {
    $buttonsHtml = '<input type="submit" value="' . $buttons . '" class="button" />';
  }
  
  // Create the submit button and close the form.
  echo <<<EOT
        <tr>
                <td colspan="2" align="center" class="tablef">
                        {$buttonsHtml}
                </td>

        </tr>

EOT;
}

