<?php
/*************************
  Coppermine Photo Gallery
  ************************
  Copyright (c) 2003-2006 Coppermine Dev Team
  v1.1 originally written by Gregory DEMAR

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  ********************************************
  Coppermine version: 1.4.4
  $Source: /cvsroot/coppermine/stable/upload.php,v $
  $Revision: 1.21 $
  $Author: gaugau $
  $Date: 2006/02/24 13:30:07 $
  ********************************************
  Coppermine version: ?
  $Source: /cvsroot/coppermine/stable/jupload.php,v $
  $Revision: ?
  $Author: Etienne Gauthier
  $Date: ?
**********************************************/



if (!defined('IN_COPPERMINE')) {
	//There can be direct access to this URL: as Coppermine central scripts (ex: login and errors) only
	//redirect to a page, without transmitting its parameters, we redirect to the plugins/jupload/jupload.php
	//Now that we are here, we redirect to  YourCoppermineInstallation/index.php?file=jupload/jupload
	
	//test url: http://localhost/coppermine/plugins/jupload/jupload.php?toto=qssqgh
	
	//Let's get all GET parameters in this query, and redirect to the correct URL.
	$parameters = '';
	foreach ($_GET as $param => $value) {
		$parameters .= '&' . urlencode($param) . '=' . urlencode($value);
	}
	echo <<<EOS
	<script language="javascript">
	document.location.replace("../../index.php?file=jupload/jupload${parameters}"); 
	</script>
EOS;
	exit;	
}


//####################################################################################################
//#################################     INCLUDES    ##################################################
//####################################################################################################

//Let's also include the upload text.
define('JUPLOAD_PHP', true);
// Activate more language block sets.
define('UPLOAD_PHP', true);
define('DB_INPUT_PHP', true);
define('ADMIN_PHP', true);
define('EDITPICS_PHP', true);

// Call basic functions, etc.
require('include/init.inc.php');
require('include/picmgmt.inc.php');
require('include/gui.inc.php');

require('plugins/jupload/include/jupload.inc.php');

//Localisation. Handled from specific files, to make upgrade of coppermine easier:
//First: we load the default text (english)
require('plugins/jupload/lang/english.php');

//Then, you overload with the choosen language, for existing translations.
//$bJuploadTranslactionExist is used later, in page_upload.php, to display a message indicating that
//the translation for the current language doesn't exist ... and to give the link to the page where all
//the text to translate is written (part of text is in the applet, not in the php code).
$bJuploadTranslactionExist = file_exists('plugins/jupload/lang/' . $USER['lang'] . '.php');

if ($USER[lang] == 'english'  ||  $USER[lang] == 'english_gb') {
	$bJuploadTranslactionExist = true;  //Was not true for english_gb, one line before ...   ;-)
} else if ($bJuploadTranslactionExist) {
    include('plugins/jupload/lang/' . $USER['lang'] . '.php');
}
//Let's call any user specific constant, like overriding of the 'standard' translation texts.
include('plugins/jupload/user/user.inc.php');

// Some placeholders.
$customize = CUSTOMIZE_UPLOAD_FORM;
$user_form = USER_UPLOAD_FORM;
$allowed_URI_boxes = NUM_URI_BOXES;
$allowed_file_boxes = NUM_FILE_BOXES;

// Check to see if user can upload pictures.  Quit with an error if he cannot.
if (!USER_CAN_UPLOAD_PICTURES) {
    //cpg_die(ERROR, $lang_jupload_php['perm_denied'], __FILE__, __LINE__);
    //redirection to Coppermine/plugins/jupload, so that the login page can redirect to the
    //plugin. See the if (!defined('IN_COPPERMINE')) {, at the beginning of the script
    cpg_die(
    	ERROR, 
    	str_replace(
			'$1', 
			'login.php?referer=plugins/jupload/jupload.php', 
			$lang_jupload_php['perm_denied']),
		__FILE__, 
		__LINE__);    
}

// Globalize $CONFIG.
global $CONFIG, $lang_jupload_php, $user_form, $max_file_size;

//Tests:  finir
//addbutton($sys_menu_buttons,'JUpload','jupload','jupload.php','upload_pic',$template_sys_menu_spacer);


//####################################################################################################
//#################################    FUNCTIONS    ##################################################
//####################################################################################################




///////////////////////////////////////////////////////////////////////
///////////////   INIT OF SCRIPT VARIABLES  ///////////////////////////
///////////////////////////////////////////////////////////////////////

//Initialize local parameters.
$action				= isset($_POST['action']			) ? $_POST['action'] 			: $_GET['action'];
$album				= isset($_POST['album']				) ? ( (int) $_POST['album']) 	: (isset($_GET['album'])?(int)$_GET['album']:0);
$album_name			= isset($_POST['album_name']		) ? $_POST['album_name'] 		: '';
$album_description	= isset($_POST['album_description'] ) ? $_POST['album_description'] : '';


// Get public and private albums, and set maximum individual file size.

if (GALLERY_ADMIN_MODE) {
    $public_albums = cpg_db_query("SELECT aid, title, description  FROM {$CONFIG['TABLE_ALBUMS']} WHERE category < " . FIRST_USER_CAT . " ORDER BY title");
} else {
	$public_albums = cpg_db_query("SELECT aid, title, description  FROM {$CONFIG['TABLE_ALBUMS']} WHERE category < " . FIRST_USER_CAT . " AND uploads='YES' AND (visibility = '0' OR visibility IN ".USER_GROUP_SET.") ORDER BY title");
}
if (mysql_num_rows($public_albums)) {
    $public_albums_list = cpg_db_fetch_rowset($public_albums);
} else {
    $public_albums_list = array();
}

if (USER_ID) {
    $user_albums = cpg_db_query("SELECT aid, title, description FROM {$CONFIG['TABLE_ALBUMS']} WHERE category='" . (FIRST_USER_CAT + USER_ID) . "' ORDER BY title");
    if (mysql_num_rows($user_albums)) {
        $user_albums_list = cpg_db_fetch_rowset($user_albums);
    } else {
        $user_albums_list = array();
    }
} else {
    $user_albums_list = array();
}

/*
if (!count($public_albums_list) && !count($user_albums_list)) {
    cpg_die (ERROR, $lang_upload_php['err_no_alb_uploadables'], __FILE__, __LINE__);
}
*/

// Assign maximum file size for browser crontrols.
//$max_file_size = $CONFIG['max_upl_size'] << 10;



if ($album_name == ''  && $album > 0) {
	//Let's get the album name and description for the selected album. 
	$found = false;
    foreach($user_albums_list as $a) {
    	if ($a['aid'] == $album) {
    		$found = true;
    		$album_name = $a['title'];
    		$album_description = $a['description'];
    	}
    }
    if (!$found) {
	    foreach($public_albums_list as $a) {
	    	if ($a['aid'] == $album) {
	    		$found = true;
	    		$album_name = $a['title'];
	    		$album_description = $a['description'];
	    	}
	    }
    }
}


//####################################################################################################
//################################# MAIN CODE BLOCK ##################################################
//####################################################################################################


///////////////////////////////////////////////////////////////////////
/////////////////   HANDLE OF INCOMING ACTIONS  (if any)  /////////////
///////////////////////////////////////////////////////////////////////


switch ($action) {
//First: generation of the standard jupload page, containing the applet:
case 'update_album':
case 'create_album':
case '':
	require("page/upload_page.php");
	break;
//Upload of a picture from the applet. No HTML to generate.
case 'add_picture':
	require("page/upload_picture.php");
	break;
//Edition of the properties of the uploaded pictures:
case 'edit_uploaded_pics':
	require("page/edit_uploaded_pics.php");
	break;
case 'display_error':
	$text = $_GET['text'];
	$msg = $lang_jupload_php[$text];
	cpg_die(ERROR, $msg, __FILE__, __LINE__);
case 'config':
case 'store_config':
	require("page/config_page.php");
	break;
default:
	cpg_die (ERROR, 'Unknown action', __FILE__, __LINE__);
}


