<?php
/**
 * 
 * 
 * 
 */

if (!defined('IN_COPPERMINE')) { die('Not in Coppermine...');}
if (!defined('JUPLOAD_PHP')) { die('Not in Jupload...');}

//####################################################################################################
//#################################    FUNCTIONS    ##################################################
//####################################################################################################

//Insert an album into database, if the user is allowed to.
//The category is given into $cat. It's mandatory if the galery is in admin mode.
function create_album($album, $album_name, $album_description, $cat='') {
  global $lang_errors, $CONFIG, $lang_jupload_php;
  if (!(GALLERY_ADMIN_MODE || USER_ADMIN_MODE)) {
  	cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);
  }

  if ($album_name == '') cpg_die(ERROR, $lang_errors['param_missing'], __FILE__, __LINE__);

  if (GALLERY_ADMIN_MODE) {
    if ($cat == '') cpg_die(ERROR, $lang_errors['param_missing'], __FILE__, __LINE__);
    $category = (int)$_POST['cat'];
  } else {
    $category = FIRST_USER_CAT + USER_ID;
  }

  //We first check that the user doesn't already own an album with this name
  $vQuery = "SELECT count(*) nb "
    		. " FROM {$CONFIG['TABLE_ALBUMS']} " 
    		. " WHERE category = '$category'"
    		. " AND   title = '" . addslashes($album_name) . "'";
  $vRes = cpg_db_query($vQuery);
  $vRes = mysql_fetch_array($vRes);
  if ($vRes['nb'] > 0) cpg_die(ERROR, $lang_jupload_php['error_album_already_exists'], __FILE__, __LINE__);

  //Let's insert the new album.
  $query = "INSERT INTO {$CONFIG['TABLE_ALBUMS']} (category, title, description, uploads, pos) "  
    . " SELECT '$category', '" . addslashes($album_name) . "', '" . addslashes($album_description) . "', 'NO',  IFNULL(MAX(pos),101) "
    . " FROM {$CONFIG['TABLE_ALBUMS']} WHERE category = '$category' ";
  cpg_db_query($query);
  
  //Now, we select its id, to redirect the user to this album.
  $vQuery = "SELECT aid "
    		. " FROM {$CONFIG['TABLE_ALBUMS']} " 
    		. " WHERE category = '$category'"
    		. " AND   title = '" . addslashes($album_name) . "'";
  $vRes = cpg_db_query($vQuery);
  $vRes = mysql_fetch_array($vRes);

  message_success("create_album", $vRes['aid']);
}//create_album

//Update an album into database, if the user is allowed to.
function update_album($album, $album_name, $album_description) {
  global $lang_errors, $CONFIG;
  if (!(GALLERY_ADMIN_MODE || USER_ADMIN_MODE)) cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);

  if (USER_ADMIN_MODE) {
    //The user may only update its own albums. 
    $category = FIRST_USER_CAT + USER_ID;
    $user_albums = cpg_db_query("SELECT 1 FROM {$CONFIG['TABLE_ALBUMS']} WHERE category = '$category'");
    if (! mysql_num_rows($user_albums)) {
      cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);
    }
  }
  
  $query = "UPDATE {$CONFIG['TABLE_ALBUMS']} SET title='" . addslashes($album_name) 
  	. "', description='" . addslashes($album_description) . "' WHERE aid='$album' $restrict LIMIT 1";
  cpg_db_query($query);
  message_success("update_album", $album);
}//update_album


///////////////////////////////////////////////////////////////////////
/////////////////   ALBUM MANAGEMENT (if post data)  //////////////////
///////////////////////////////////////////////////////////////////////

switch ($action) {
case 'update_album':
	update_album($album, $album_name, $album_description);
	break;
case 'create_album';
	create_album($album, $album_name, $album_description);
	break;
}


///////////////////////////////////////////////////////////////////////
/////////////////   GENERATING THE HTML CONTENT    ////////////////////
///////////////////////////////////////////////////////////////////////

pageheader($lang_jupload_php['title']);

///////////////////////////////////////////////////////////////////////
//First part : some local javascript
///////////////////////////////////////////////////////////////////////

//Initialization, let's prepare the creation of the desc array : what's the bigguest album number ?
$max = 0;
foreach($user_albums_list as $a) {
  if ($a['aid'] >= $max) {
    $max = $a['aid'] + 1;
  }
}//foreach

$error_select_album = rawurlencode(html_entity_decode($lang_jupload_php['error_select_album']));
$error_album_name   = rawurlencode(html_entity_decode($lang_jupload_php['error_album_name'  ]));

//Add of the javascript function that will check that java is enabled.
addJSJavaCheck();

echo <<<EOS
  <script language="javascript" type="text/javascript">
  //What should we do, when the user selects another album ?
  function onAlbumChange() {
    if (document.form_album.album.selectedIndex >= 0) {
      document.applets['JUpload'].setProperty('albumId', document.form_album.album.value);
      document.form_album.album_name.value = document.form_album.album.options[document.form_album.album.selectedIndex].text;
      document.form_album.album_description.value = description[document.form_album.album.value];
    } else {
      document.JUpload.setProperty('albumId', '');
      document.form_album.album_name.value = '';
      document.form_album.album_description.value = '';
    }
  }
  function juploadAddPicture() {
  	if (document.form_album.album_name.value == '') {
  		alert(unescape('{$error_select_album}'));
  	} else {
	  	window.location='#applet';
  	}
	//In any case, the  submit must be refused.
	return false;
  }
  function juploadCreateAlbum() {
  	if (document.form_album.album_name.value == '') {
  		alert(unescape('{$error_album_name}'));
  		return false;
  	} else {	
	    document.form_album.action.value = 'create_album';
	    return true;
  	}	    
  }
  function juploadUpdateAlbum() {
  	if (document.form_album.album.selectedIndex == 0) {
  		alert(unescape('{$error_select_album}'));
  		return  false;
  	} else if (document.form_album.album_name.value == '') {
  		alert(unescape('{$error_album_name}'));
  		return false;
  	} else {
	    document.form_album.action.value = 'update_album';
	    return true;
  	}
  }
    
  //Creation of the album description aray.
  description = new Array($max);
EOS
;

//Initialization, let's prepare the creation of the desc array
$max = 0;
foreach($user_albums_list as $a) {
	echo (
		"description[{$a['aid']}] = '" 
		. 
		//stripcslashes (
		str_replace("\r", "",
			str_replace("\n", "\\n",
				str_replace("'", "\\'", 
					html_entity_decode($a['description']) 
				)
			)
		)
		. "';\n");
}//foreach

	//If the page is refreshed, the navigator may keep the current album selection in the list,
	//but the album is not selected in the applet. Let's deselect the album in the list, when running this
	//page. I'll find a better solution, later.
echo <<<EOS
	document.form_album.album.selectedIndex = -1;  
  </script>
EOS
;

///////////////////////////////////////////////////////////////////////
//Second part : the selection of the album
///////////////////////////////////////////////////////////////////////

echo ('<form method="post" name="form_album" enctype="multipart/form-data" action="' . $_SERVER['PHP_SELF'] . '">');
		starttable("100%", $lang_jupload_php['select_album'], 2);
		if (! $bJuploadTranslactionExist) {
			form_statement ('<B><I>The JUpload translation for this language doesn\'t exist. </B>'
				. 'If you want to create it, please go to the <a href="http://etienne.lesgauthier.fr/wiki/doku.php?id=jupload_translation">JUpload translation page</a>.</I>'
				);
		}	
		form_statement ($lang_jupload_php['album_presentation']);
		form_alb_list_box ($lang_jupload_php['album'], "album", 'onChange="onAlbumChange()"');
		hidden_input('action', 'no action');
		//A default value is given only if the album number (in $album) is given:
		text_box_input($lang_jupload_php['album_name'], 'album_name', 255, 1, (($album>0)?$album_name:'')); 
		text_area_input($lang_jupload_php['album_description'], 'album_description', 2000, (($album>0)?$album_description:''));
		$submit_buttons = array (
			    array( 'value'  =>  $lang_jupload_php['add_pictures'], 'js' => 'onClick="return juploadAddPicture()"'),
			    array( 'value'  =>  $lang_jupload_php['button_update_album'], 'js' => 'onClick="return juploadUpdateAlbum()"')
		    );
		//if (! (GALLERY_ADMIN_MODE || USER_ADMIN_MODE) ) {
		if (USER_ADMIN_MODE) {
			$submit_buttons[] = array( 'value'  =>  $lang_jupload_php['button_create_album'], 'js' => 'onClick="return juploadCreateAlbum()"');
		}
		submit_button($submit_buttons);
	endtable();
echo ("</form>");


///////////////////////////////////////////////////////////////////////
//Third part : the upload applet
///////////////////////////////////////////////////////////////////////

starttable("100%", '<a name="applet"></a>'.$lang_jupload_php['add_pictures'], 2);

  //$URL = $CONFIG['site_url'] . 'xp_publish.php';
  //$URL = $CONFIG['site_url'] . 'plugins/jupload/upload_picture.php';
  $URL = $CONFIG['site_url'] . 'index.php?file=jupload/jupload&action=add_picture';
  
  $urlToSendErrorTo = $CONFIG['site_url'] . 'index.php?file=jupload/log_error';

  form_label ($lang_jupload_php['max_upload_size'], $CONFIG['max_upl_size']);
  form_statement ($lang_jupload_php['upload_presentation']);
  /*
   * Below : use of the standard applet tag for all. This is simpler, and seems to work better ... now. This
   * was probably wrong when the original jupload was released, in 2002. 
   */
  form_label (<<<EOS
  	<CENTER>
      <APPLET  
          NAME="JUpload"
          CODE="wjhk.jupload2.JUploadApplet" 
          ARCHIVE="plugins/jupload/wjhk.jupload.jar" 
          WIDTH="640" 
          HEIGHT="500"
          MAYSCRIPT
          >
          <PARAM NAME="albumId"             VALUE="$album">
          <PARAM NAME="debugLevel"          VALUE="0">
          <PARAM NAME="lang"                VALUE="${lang_translation_info['lang_country_code']}">
          <!-- PARAM NAME="filenameEncoding"    VALUE="utf-8" -->
          <PARAM NAME="highQualityPreview"  VALUE="true">
          <PARAM NAME="maxPicHeight"        VALUE="${CONFIG['max_upl_width_height']}">
          <PARAM NAME="maxPicWidth"         VALUE="${CONFIG['max_upl_width_height']}">
          <PARAM NAME="nbFilesPerRequest"   VALUE="1">
          <PARAM NAME="postURL"             VALUE="$URL">
          <PARAM NAME="serverProtocol"      VALUE="${_SERVER['SERVER_PROTOCOL']}">
          <PARAM NAME="stringUploadSuccess" VALUE="SUCCESS">
          <PARAM NAME="uploadPolicy"        VALUE="CoppermineUploadPolicy">
          <PARAM NAME="urlToSendErrorTo"    VALUE="$urlToSendErrorTo">
                
      Java 1.4 or higher plugin required.
      </APPLET>
   </CENTER>
EOS
  );

endtable();


//If there is a selected album, we tell it to the applet.
if ($album > 0) {
	echo <<<EOS
		<script language='javascript'>
		document.applets['JUpload'].setProperty('albumId', ${album});
		</script>
EOS
;
}


pagefooter();
ob_end_flush();

